Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablmod.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablmod.F90	(revision 13228)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/ABL/ablmod.F90	(revision 13229)
@@ -2,10 +2,10 @@
    !!======================================================================
    !!                       ***  MODULE  ablmod  ***
-   !! Surface module :  ABL computation to provide atmospheric data 
+   !! Surface module :  ABL computation to provide atmospheric data
    !!                   for surface fluxes computation
    !!======================================================================
    !! History :  3.6  ! 2019-03  (F. Lemarié & G. Samson)  Original code
    !!----------------------------------------------------------------------
-   
+
    !!----------------------------------------------------------------------
    !!   abl_stp       : ABL single column model
@@ -16,7 +16,7 @@
 
    USE phycst         ! physical constants
-   USE dom_oce, ONLY  : tmask  
+   USE dom_oce, ONLY  : tmask
    USE sbc_oce, ONLY  : ght_abl, ghw_abl, e3t_abl, e3w_abl, jpka, jpkam1, rhoa
-   USE sbcblk         ! use rn_?fac
+   USE sbcblk         ! use rn_efac, cdn_oce
    USE sbcblk_phy     ! use some physical constants for flux computation
    !
@@ -30,5 +30,5 @@
 
    PUBLIC   abl_stp   ! called by sbcabl.F90
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ustar2
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ustar2, zrough
    !! * Substitutions
 #  include "do_loop_substitute.h90"
@@ -38,15 +38,16 @@
 
 !===================================================================================================
-   SUBROUTINE abl_stp( kt, psst, pssu, pssv, pssq, &                            ! in
-              &            pu_dta, pv_dta, pt_dta, pq_dta,    & 
+   SUBROUTINE abl_stp( kt, psst, pssu, pssv, pssq,            &     ! in
+              &            pu_dta, pv_dta, pt_dta, pq_dta,    &
               &            pslp_dta, pgu_dta, pgv_dta,        &
-              &            pcd_du, psen, pevp,                &                            ! in/out
-              &            pwndm, ptaui, ptauj, ptaum         & 
-#if defined key_si3			  
-              &          , ptm_su,pssu_ice,pssv_ice,pssq_ice,pcd_du_ice  & 
-              &          , psen_ice, pevp_ice, pwndm_ice, pfrac_oce      & 
-              &          , ptaui_ice, ptauj_ice                          &
-#endif			  
-			  &   )
+              &            pcd_du, psen, pevp,                &     ! in/out
+              &            pwndm, ptaui, ptauj, ptaum         &
+#if defined key_si3
+              &          , ptm_su, pssu_ice, pssv_ice         &
+              &          , pssq_ice, pcd_du_ice, psen_ice     &
+              &          , pevp_ice, pwndm_ice, pfrac_oce     &
+              &          , ptaui_ice, ptauj_ice               &
+#endif
+              &      )
 !---------------------------------------------------------------------------------------------------
 
@@ -54,9 +55,9 @@
       !!                    ***  ROUTINE abl_stp ***
       !!
-      !! ** Purpose :   Time-integration of the ABL model 
+      !! ** Purpose :   Time-integration of the ABL model
       !!
-      !! ** Method  :   Compute atmospheric variables : vertical turbulence 
+      !! ** Method  :   Compute atmospheric variables : vertical turbulence
       !!                             + Coriolis term + newtonian relaxation
-      !!                
+      !!
       !! ** Action  : - Advance TKE to time n+1 and compute Avm_abl, Avt_abl, PBLh
       !!              - Advance tracers to time n+1 (Euler backward scheme)
@@ -70,5 +71,5 @@
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   psst       ! sea-surface temperature [Celsius]
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssu       ! sea-surface u (U-point)
-      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssv       ! sea-surface v (V-point) 
+      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssv       ! sea-surface v (V-point)
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssq       ! sea-surface humidity
       REAL(wp) , INTENT(in   ), DIMENSION(:,:,:) ::   pu_dta     ! large-scale windi
@@ -82,37 +83,36 @@
       REAL(wp) , INTENT(inout), DIMENSION(:,:  ) ::   psen       ! Ch x Du
       REAL(wp) , INTENT(inout), DIMENSION(:,:  ) ::   pevp       ! Ce x Du
-      REAL(wp) , INTENT(inout), DIMENSION(:,:  ) ::   pwndm      ! ||uwnd||      
+      REAL(wp) , INTENT(inout), DIMENSION(:,:  ) ::   pwndm      ! ||uwnd||
       REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptaui      ! taux
       REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptauj      ! tauy
-      REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptaum      ! ||tau|| 
-      !
-#if defined key_si3	  
+      REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptaum      ! ||tau||
+      !
+#if defined key_si3
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   ptm_su       ! ice-surface temperature [K]
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssu_ice     ! ice-surface u (U-point)
-      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssv_ice     ! ice-surface v (V-point) 	  
-      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssq_ice     ! ice-surface humidity 
+      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssv_ice     ! ice-surface v (V-point)
+      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pssq_ice     ! ice-surface humidity
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pcd_du_ice   ! Cd x Du over ice (T-point)
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   psen_ice     ! Ch x Du over ice (T-point)
       REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pevp_ice     ! Ce x Du over ice (T-point)
-      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pwndm_ice    ! ||uwnd - uice||  
-      !REAL(wp) , INTENT(inout), DIMENSION(:,:  ) ::   pfrac_oce	   !!GS: out useless ?
-      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pfrac_oce	   !
+      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pwndm_ice    ! ||uwnd - uice||
+      REAL(wp) , INTENT(in   ), DIMENSION(:,:  ) ::   pfrac_oce    ! ocean fraction
       REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptaui_ice    ! ice-surface taux stress (U-point)
-      REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptauj_ice    ! ice-surface tauy stress (V-point) 	  
-#endif	  
-      !
-      REAL(wp), DIMENSION(1:jpi,1:jpj   )        ::   zwnd_i, zwnd_j
-      REAL(wp), DIMENSION(1:jpi,2:jpka  )        ::   zCF    
-      REAL(wp), DIMENSION(1:jpi,1:jpj,1:jpka)    ::   z_cft      !--FL--to be removed after the test phase   
-      !
-      REAL(wp), DIMENSION(1:jpi,1:jpka  )        ::   z_elem_a
-      REAL(wp), DIMENSION(1:jpi,1:jpka  )        ::   z_elem_b
-      REAL(wp), DIMENSION(1:jpi,1:jpka  )        ::   z_elem_c
+      REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptauj_ice    ! ice-surface tauy stress (V-point)
+#endif
+      !
+      REAL(wp), DIMENSION(1:jpi,1:jpj       )    ::   zwnd_i, zwnd_j
+      REAL(wp), DIMENSION(1:jpi      ,2:jpka)    ::   zCF
+      !
+      REAL(wp), DIMENSION(1:jpi      ,1:jpka)    ::   z_elem_a
+      REAL(wp), DIMENSION(1:jpi      ,1:jpka)    ::   z_elem_b
+      REAL(wp), DIMENSION(1:jpi      ,1:jpka)    ::   z_elem_c
       !
       INTEGER             ::   ji, jj, jk, jtra, jbak               ! dummy loop indices
       REAL(wp)            ::   zztmp, zcff, ztemp, zhumi, zcff1, zztmp1, zztmp2
       REAL(wp)            ::   zcff2, zfcor, zmsk, zsig, zcffu, zcffv, zzice,zzoce
-      !
-      !!---------------------------------------------------------------------      
+      LOGICAL             ::   SemiImp_Cor = .TRUE.
+      !
+      !!---------------------------------------------------------------------
       !
       IF(lwp .AND. kt == nit000) THEN                  ! control print
@@ -120,18 +120,20 @@
          WRITE(numout,*) 'abl_stp : ABL time stepping'
          WRITE(numout,*) '~~~~~~'
-      ENDIF 
+      ENDIF
       !
       IF( kt == nit000 ) ALLOCATE ( ustar2( 1:jpi, 1:jpj ) )
-      !! Compute ustar squared as Cd || Uatm-Uoce ||^2 
-      !! needed for surface boundary condition of TKE 
+      IF( kt == nit000 ) ALLOCATE ( zrough( 1:jpi, 1:jpj ) )
+      !! Compute ustar squared as Cd || Uatm-Uoce ||^2
+      !! needed for surface boundary condition of TKE
       !! pwndm contains | U10m - U_oce | (see blk_oce_1 in sbcblk)
       DO_2D_11_11
          zzoce         = pCd_du    (ji,jj) * pwndm    (ji,jj)
 #if defined key_si3
-         zzice         = pCd_du_ice(ji,jj) * pwndm_ice(ji,jj) 
-         ustar2(ji,jj) = zzoce * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * zzice 
+         zzice         = pCd_du_ice(ji,jj) * pwndm_ice(ji,jj)
+         ustar2(ji,jj) = zzoce * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * zzice
 #else
-         ustar2(ji,jj) = zzoce	
+         ustar2(ji,jj) = zzoce
 #endif
+         zrough(ji,jj) = ght_abl(2) * EXP( - vkarmn / SQRT( MAX( Cdn_oce(ji,jj), 1.e-4 ) ) ) !<-- recover the value of z0 from Cdn_oce
       END_2D
       !
@@ -140,201 +142,247 @@
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
-      CALL abl_zdf_tke( )                       !--> Avm_abl, Avt_abl, pblh defined on (1,jpi) x (1,jpj) 
-         
+      CALL abl_zdf_tke( )                       !--> Avm_abl, Avt_abl, pblh defined on (1,jpi) x (1,jpj)
+
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !                            !  2 *** Advance tracers to time n+1
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      
+
       !-------------
       DO jj = 1, jpj    ! outer loop             !--> tq_abl computed on (1:jpi) x (1:jpj)
-      !-------------    
-         ! Compute matrix elements for interior points 
+      !-------------
+         ! Compute matrix elements for interior points
          DO jk = 3, jpkam1
             DO ji = 1, jpi   ! vector opt.
-               z_elem_a( ji,     jk              ) = - rDt_abl * Avt_abl( ji, jj, jk-1 ) / e3w_abl( jk-1 )   ! lower-diagonal
-               z_elem_c( ji,     jk              ) = - rDt_abl * Avt_abl( ji, jj, jk   ) / e3w_abl( jk   )   ! upper-diagonal       
-               z_elem_b( ji,     jk              ) = e3t_abl(jk) - z_elem_a( ji, jk ) - z_elem_c( ji, jk )   !       diagonal           
-            END DO
-         END DO  
-         ! Boundary conditions  
-         DO ji = 1, jpi   ! vector opt. 
-            ! Neumann at the bottom          
-            z_elem_a( ji,     2              ) = 0._wp
-            z_elem_c( ji,     2              ) = - rDt_abl * Avt_abl( ji, jj, 2   ) / e3w_abl( 2   )                                         
+               z_elem_a( ji, jk ) = - rDt_abl * Avt_abl( ji, jj, jk-1 ) / e3w_abl( jk-1 )   ! lower-diagonal
+               z_elem_c( ji, jk ) = - rDt_abl * Avt_abl( ji, jj, jk   ) / e3w_abl( jk   )   ! upper-diagonal
+               z_elem_b( ji, jk ) = e3t_abl(jk) - z_elem_a( ji, jk ) - z_elem_c( ji, jk )   !       diagonal
+            END DO
+         END DO
+         ! Boundary conditions
+         DO ji = 1, jpi   ! vector opt.
+            ! Neumann at the bottom
+            z_elem_a( ji,    2 ) = 0._wp
+            z_elem_c( ji,    2 ) = - rDt_abl * Avt_abl( ji, jj,    2 ) / e3w_abl(    2 )
             ! Homogeneous Neumann at the top
-            z_elem_a( ji,     jpka           ) = - rDt_abl * Avt_abl( ji, jj, jpka ) / e3w_abl( jpka ) 
-            z_elem_c( ji,     jpka           ) = 0._wp
-            z_elem_b( ji,     jpka           ) = e3t_abl( jpka ) - z_elem_a( ji,     jpka )
-         END DO            
+            z_elem_a( ji, jpka ) = - rDt_abl * Avt_abl( ji, jj, jpka ) / e3w_abl( jpka )
+            z_elem_c( ji, jpka ) = 0._wp
+            z_elem_b( ji, jpka ) = e3t_abl( jpka ) - z_elem_a( ji, jpka )
+         END DO
 
          DO jtra = 1,jptq  ! loop on active tracers
-               
+
             DO jk = 3, jpkam1
-               DO ji = 1,jpi
-                  tq_abl  ( ji, jj, jk, nt_a, jtra ) = e3t_abl(jk) * tq_abl  ( ji, jj, jk, nt_n, jtra )   ! initialize right-hand-side
+               !DO ji = 2, jpim1
+               DO ji = 1,jpi  !!GS: to be checked if needed
+                  tq_abl( ji, jj, jk, nt_a, jtra ) = e3t_abl(jk) * tq_abl( ji, jj, jk, nt_n, jtra )   ! initialize right-hand-side
                END DO
             END DO
 
             IF(jtra == jp_ta) THEN
-               DO ji = 1,jpi  ! boundary conditions for temperature              
-                  zztmp1 = psen(ji, jj) 
-                  zztmp2 = psen(ji, jj) * ( psst(ji, jj) + rt0 )	
-#if defined key_si3				  
-                  zztmp1 = zztmp1 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * psen_ice(ji,jj) 
+               DO ji = 1,jpi  ! surface boundary condition for temperature
+                  zztmp1 = psen(ji, jj)
+                  zztmp2 = psen(ji, jj) * ( psst(ji, jj) + rt0 )
+#if defined key_si3
+                  zztmp1 = zztmp1 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * psen_ice(ji,jj)
                   zztmp2 = zztmp2 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * psen_ice(ji,jj) * ptm_su(ji,jj)
-#endif				  
-                  z_elem_b( ji,     2                ) = e3t_abl( 2 ) - z_elem_c( ji, 2 ) + rDt_abl * zztmp1				  
-                  tq_abl  ( ji, jj, 2   , nt_a, jtra ) = e3t_abl( 2    ) * tq_abl  ( ji, jj, 2   , nt_n, jtra ) + rDt_abl * zztmp2               
+#endif
+                  z_elem_b( ji,        2             ) = e3t_abl(    2 ) - z_elem_c( ji,        2             ) + rDt_abl * zztmp1
+                  tq_abl  ( ji, jj,    2, nt_a, jtra ) = e3t_abl(    2 ) * tq_abl  ( ji, jj,    2, nt_n, jtra ) + rDt_abl * zztmp2
                   tq_abl  ( ji, jj, jpka, nt_a, jtra ) = e3t_abl( jpka ) * tq_abl  ( ji, jj, jpka, nt_n, jtra )
-               END DO 
-            ELSE   
-               DO ji = 1,jpi  ! boundary conditions for humidity              
-                  zztmp1 = pevp(ji, jj) 
-                  zztmp2 = pevp(ji, jj) * pssq(ji, jj)   
-#if defined key_si3				  
-                  zztmp1 = zztmp1 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * pevp_ice(ji,jj) 
-                  zztmp2 = zztmp2 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * pevp_ice(ji, jj) * pssq_ice(ji, jj)    
-#endif	
-                  z_elem_b( ji,     2                ) = e3t_abl( 2 ) - z_elem_c( ji, 2 ) + rDt_abl * zztmp1
-                  tq_abl  ( ji, jj, 2   , nt_a, jtra ) = e3t_abl( 2    ) * tq_abl  ( ji, jj, 2   , nt_n, jtra ) + rDt_abl * zztmp2               
+               END DO
+            ELSE ! jp_qa
+               DO ji = 1,jpi  ! surface boundary condition for humidity
+                  zztmp1 = pevp(ji, jj)
+                  zztmp2 = pevp(ji, jj) * pssq(ji, jj)
+#if defined key_si3
+                  zztmp1 = zztmp1 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * pevp_ice(ji,jj)
+                  zztmp2 = zztmp2 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * pevp_ice(ji, jj) * pssq_ice(ji, jj)
+#endif
+                  z_elem_b( ji,     2                ) = e3t_abl(    2 ) - z_elem_c( ji,        2             ) + rDt_abl * zztmp1
+                  tq_abl  ( ji, jj, 2   , nt_a, jtra ) = e3t_abl(    2 ) * tq_abl  ( ji, jj,    2, nt_n, jtra ) + rDt_abl * zztmp2
                   tq_abl  ( ji, jj, jpka, nt_a, jtra ) = e3t_abl( jpka ) * tq_abl  ( ji, jj, jpka, nt_n, jtra )
-               END DO                                     
+               END DO
             END IF
             !!
             !! Matrix inversion
             !! ----------------------------------------------------------
-            DO ji = 1,jpi            
-               zcff                       =  1._wp / z_elem_b( ji, 2 )
-               zCF   (ji,   2           ) = - zcff * z_elem_c( ji, 2 )
-               tq_abl(ji,jj,2,nt_a,jtra) =    zcff * tq_abl(ji,jj,2,nt_a,jtra)
-            END DO             
-
-            DO jk = 3, jpka            
-               DO ji = 1,jpi            
-                  zcff = 1._wp / ( z_elem_b( ji, jk ) + z_elem_a( ji, jk ) * zCF   (ji, jk-1 ) )
+            DO ji = 1,jpi
+               zcff                            =  1._wp / z_elem_b( ji, 2 )
+               zCF   ( ji,     2             ) = - zcff * z_elem_c( ji, 2 )
+               tq_abl( ji, jj, 2, nt_a, jtra ) =   zcff * tq_abl( ji, jj, 2, nt_a, jtra )
+            END DO
+
+            DO jk = 3, jpka
+               DO ji = 1,jpi
+                  zcff = 1._wp / ( z_elem_b( ji, jk ) + z_elem_a( ji, jk ) * zCF( ji, jk-1 ) )
                   zCF(ji,jk) = - zcff * z_elem_c( ji, jk )
                   tq_abl(ji,jj,jk,nt_a,jtra) = zcff * ( tq_abl(ji,jj,jk  ,nt_a,jtra)   &
-                  &                - z_elem_a(ji, jk) * tq_abl(ji,jj,jk-1,nt_a,jtra) )
-               END DO
-            END DO
-!!FL at this point we could check positivity of tq_abl(:,:,:,nt_a,jp_qa) ... test to do ...         
-            DO jk = jpkam1,2,-1            
-               DO ji = 1,jpi  
+                     &           - z_elem_a(ji, jk) *   tq_abl(ji,jj,jk-1,nt_a,jtra) )
+               END DO
+            END DO
+            !!FL at this point we could check positivity of tq_abl(:,:,:,nt_a,jp_qa) ... test to do ...
+            DO jk = jpkam1,2,-1
+               DO ji = 1,jpi
                   tq_abl(ji,jj,jk,nt_a,jtra) = tq_abl(ji,jj,jk,nt_a,jtra) +    &
                      &                        zCF(ji,jk) * tq_abl(ji,jj,jk+1,nt_a,jtra)
                END DO
             END DO
-         
-         END DO   !<-- loop on tracers                    
-         !! 
-      !-------------
-      END DO             ! end outer loop 
-      !-------------   
-      
-      
+
+         END DO   !<-- loop on tracers
+         !!
+      !-------------
+      END DO             ! end outer loop
+      !-------------
+
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !                            !  3 *** Compute Coriolis term with geostrophic guide
-      !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
-      !-------------        
-      DO jk = 2, jpka    ! outer loop
-      !-------------
-         !             
-         ! Advance u_abl & v_abl to time n+1
-         DO_2D_11_11
-            zcff = ( fft_abl(ji,jj) * rDt_abl )*( fft_abl(ji,jj) * rDt_abl )  ! (f dt)**2
+      !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      IF( SemiImp_Cor ) THEN
+
+         !-------------
+         DO jk = 2, jpka    ! outer loop
+         !-------------
+            !
+            ! Advance u_abl & v_abl to time n+1
+            DO_2D_11_11
+               zcff = ( fft_abl(ji,jj) * rDt_abl )*( fft_abl(ji,jj) * rDt_abl )  ! (f dt)**2
+
+               u_abl( ji, jj, jk, nt_a ) = e3t_abl(jk) *(                                          &
+                  &        (1._wp-gamma_Cor*(1._wp-gamma_Cor)*zcff) * u_abl( ji, jj, jk, nt_n )    &
+                  &                     + rDt_abl * fft_abl(ji, jj) * v_abl( ji, jj, jk, nt_n ) )  &
+                  &                               / (1._wp + gamma_Cor*gamma_Cor*zcff)
    
-            u_abl( ji, jj, jk, nt_a ) = e3t_abl(jk) *(  &
-               &        (1._wp-gamma_Cor*(1._wp-gamma_Cor)*zcff)*u_abl( ji, jj, jk, nt_n )    &
-               &                 +  rDt_abl * fft_abl(ji, jj) * v_abl ( ji , jj  , jk, nt_n ) )  &
-               &                               / (1._wp + gamma_Cor*gamma_Cor*zcff)
-               
-            v_abl( ji, jj, jk, nt_a ) =  e3t_abl(jk) *(  &
-               &        (1._wp-gamma_Cor*(1._wp-gamma_Cor)*zcff)*v_abl( ji, jj, jk, nt_n )   &
-               &                 -  rDt_abl * fft_abl(ji, jj) * u_abl ( ji   , jj, jk, nt_n )  ) &
-               &                                / (1._wp + gamma_Cor*gamma_Cor*zcff)                
-         END_2D
-         !                                   
-      !-------------
-      END DO             ! end outer loop  !<-- u_abl and v_abl are properly updated on (1:jpi) x (1:jpj)
-      !-------------                
-      !
-      IF( ln_geos_winds ) THEN
-         DO jj = 1, jpj    ! outer loop       
-            DO jk = 1, jpka
-               DO ji = 1, jpi 
-                  u_abl( ji, jj, jk, nt_a ) = u_abl( ji, jj, jk, nt_a )   &
-                     &                      - rDt_abl * e3t_abl(jk) * fft_abl(ji  , jj) * pgv_dta(ji  ,jj  ,jk)
-                  v_abl( ji, jj, jk, nt_a ) = v_abl( ji, jj, jk, nt_a )   &
-                     &                      + rDt_abl * e3t_abl(jk) * fft_abl(ji, jj  ) * pgu_dta(ji  ,jj  ,jk)
-               END DO
-            END DO
-         END DO      
-      END IF 
-      !-------------            
-      !
-      IF( ln_hpgls_frc ) THEN
-         DO jj = 1, jpj    ! outer loop       
-            DO jk = 1, jpka
-               DO ji = 1, jpi 
-                  u_abl( ji, jj, jk, nt_a ) = u_abl( ji, jj, jk, nt_a ) - rDt_abl * e3t_abl(jk) * pgu_dta(ji,jj,jk)
-                  v_abl( ji, jj, jk, nt_a ) = v_abl( ji, jj, jk, nt_a ) - rDt_abl * e3t_abl(jk) * pgv_dta(ji,jj,jk)  
+               v_abl( ji, jj, jk, nt_a ) =  e3t_abl(jk) *(                                         &
+                  &        (1._wp-gamma_Cor*(1._wp-gamma_Cor)*zcff) * v_abl( ji, jj, jk, nt_n )    &
+                  &                     - rDt_abl * fft_abl(ji, jj) * u_abl( ji, jj, jk, nt_n ) )  &
+                  &                               / (1._wp + gamma_Cor*gamma_Cor*zcff)
+            END_2D
+            !
+         !-------------
+         END DO             ! end outer loop  !<-- u_abl and v_abl are properly updated on (1:jpi) x (1:jpj)
+         !-------------
+         !
+         IF( ln_geos_winds ) THEN
+            DO jj = 1, jpj    ! outer loop
+               DO jk = 1, jpka
+                  DO ji = 1, jpi
+                     u_abl( ji, jj, jk, nt_a ) = u_abl( ji, jj, jk, nt_a )   &
+                        &                      - rDt_abl * e3t_abl(jk) * fft_abl(ji  , jj) * pgv_dta(ji  ,jj  ,jk)
+                     v_abl( ji, jj, jk, nt_a ) = v_abl( ji, jj, jk, nt_a )   &
+                        &                      + rDt_abl * e3t_abl(jk) * fft_abl(ji, jj  ) * pgu_dta(ji  ,jj  ,jk)
+                  END DO
+               END DO
+            END DO
+         END IF
+         !
+         IF( ln_hpgls_frc ) THEN
+            DO jj = 1, jpj    ! outer loop
+               DO jk = 1, jpka
+                  DO ji = 1, jpi
+                     u_abl( ji, jj, jk, nt_a ) = u_abl( ji, jj, jk, nt_a ) - rDt_abl * e3t_abl(jk) * pgu_dta(ji,jj,jk)
+                     v_abl( ji, jj, jk, nt_a ) = v_abl( ji, jj, jk, nt_a ) - rDt_abl * e3t_abl(jk) * pgv_dta(ji,jj,jk)
+                  ENDDO
                ENDDO
             ENDDO
-         ENDDO 
-      END IF
-	  
-      !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      !                            !  4 *** Advance u,v to time n+1 
-      !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
-      !
-      !  Vertical diffusion for u_abl     
+         END IF
+
+      ELSE ! SemiImp_Cor = .FALSE.
+
+         IF( ln_geos_winds ) THEN
+
+            !-------------
+            DO jk = 2, jpka    ! outer loop
+            !-------------
+               !
+               IF( MOD( kt, 2 ) == 0 ) then
+                  ! Advance u_abl & v_abl to time n+1
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        zcff = fft_abl(ji,jj) * ( v_abl ( ji , jj  , jk, nt_n ) - pgv_dta(ji  ,jj  ,jk)  )
+                        u_abl( ji, jj, jk, nt_a ) =                u_abl( ji, jj, jk, nt_n ) + rDt_abl * zcff
+                        zcff = fft_abl(ji,jj) * ( u_abl ( ji , jj  , jk, nt_a ) - pgu_dta(ji  ,jj  ,jk)  )
+                        v_abl( ji, jj, jk, nt_a ) = e3t_abl(jk) *( v_abl( ji, jj, jk, nt_n ) - rDt_abl * zcff )
+                        u_abl( ji, jj, jk, nt_a ) = e3t_abl(jk) *  u_abl( ji, jj, jk, nt_a )
+                     END DO
+                  END DO
+               ELSE
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        zcff = fft_abl(ji,jj) * ( u_abl ( ji , jj  , jk, nt_n ) - pgu_dta(ji  ,jj  ,jk)  )
+                        v_abl( ji, jj, jk, nt_a ) =                v_abl( ji, jj, jk, nt_n ) - rDt_abl * zcff
+                        zcff = fft_abl(ji,jj) * ( v_abl ( ji , jj  , jk, nt_a ) - pgv_dta(ji  ,jj  ,jk)  )
+                        u_abl( ji, jj, jk, nt_a ) = e3t_abl(jk) *( u_abl( ji, jj, jk, nt_n ) + rDt_abl * zcff )
+                        v_abl( ji, jj, jk, nt_a ) = e3t_abl(jk) *  v_abl( ji, jj, jk, nt_a )
+                     END DO
+                  END DO
+               END IF
+               !
+            !-------------
+            END DO             ! end outer loop  !<-- u_abl and v_abl are properly updated on (1:jpi) x (1:jpj)
+            !-------------
+
+         ENDIF ! ln_geos_winds
+
+      ENDIF ! SemiImp_Cor
+      !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      !                            !  4 *** Advance u,v to time n+1
+      !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      !
+      !  Vertical diffusion for u_abl
       !-------------
       DO jj = 1, jpj    ! outer loop
-      !-------------    
+      !-------------
 
          DO jk = 3, jpkam1
-            DO ji = 1, jpi  
-               z_elem_a( ji,     jk ) = - rDt_abl * Avm_abl( ji, jj, jk-1 ) / e3w_abl( jk-1 )  ! lower-diagonal
-               z_elem_c( ji,     jk ) = - rDt_abl * Avm_abl( ji, jj, jk   ) / e3w_abl( jk   )  ! upper-diagonal                
-               z_elem_b( ji,     jk ) = e3t_abl(jk) - z_elem_a( ji, jk ) - z_elem_c( ji, jk )                             !       diagonal
-            END DO
-         END DO  
-            
-         DO ji = 2, jpi   ! boundary conditions   (Avm_abl and pcd_du must be available at ji=jpi)            
+            DO ji = 1, jpi
+               z_elem_a( ji, jk ) = - rDt_abl * Avm_abl( ji, jj, jk-1 ) / e3w_abl( jk-1 )  ! lower-diagonal
+               z_elem_c( ji, jk ) = - rDt_abl * Avm_abl( ji, jj, jk   ) / e3w_abl( jk   )  ! upper-diagonal
+               z_elem_b( ji, jk ) = e3t_abl(jk) - z_elem_a( ji, jk ) - z_elem_c( ji, jk )  !       diagonal
+            END DO
+         END DO
+
+         DO ji = 2, jpi   ! boundary conditions   (Avm_abl and pcd_du must be available at ji=jpi)
             !++ Surface boundary condition
-            z_elem_a( ji,     2    ) = 0._wp
-            z_elem_c( ji,     2    ) = - rDt_abl * Avm_abl( ji, jj, 2   ) / e3w_abl( 2   )                                       
-            !
-			zztmp1  = pcd_du(ji, jj)
-			zztmp2  = 0.5_wp * pcd_du(ji, jj) * ( pssu(ji-1, jj) + pssu(ji,jj) )			
-#if defined key_si3				  
+            z_elem_a( ji, 2 ) = 0._wp
+            z_elem_c( ji, 2 ) = - rDt_abl * Avm_abl( ji, jj, 2 ) / e3w_abl( 2 )
+            !
+            zztmp1  = pcd_du(ji, jj)
+            zztmp2  = 0.5_wp * pcd_du(ji, jj) * ( pssu(ji-1, jj) + pssu(ji,jj) )
+#if defined key_si3
             zztmp1 = zztmp1 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * pcd_du_ice(ji, jj)
-			zzice  = 0.5_wp * ( pssu_ice(ji-1, jj) + pssu_ice(ji,jj) )
-			zztmp2 = zztmp2 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * pcd_du_ice(ji, jj) * zzice
-#endif           
-			z_elem_b( ji,     2       ) = e3t_abl( 2 ) - z_elem_c( ji, 2 ) + rDt_abl * zztmp1 			
+            zzice  = 0.5_wp * ( pssu_ice(ji-1, jj) + pssu_ice(ji, jj) )
+            zztmp2 = zztmp2 * pfrac_oce(ji,jj) + (1._wp - pfrac_oce(ji,jj)) * pcd_du_ice(ji, jj) * zzice
+#endif
+            z_elem_b( ji,     2       ) = e3t_abl( 2 ) - z_elem_c( ji, 2 ) + rDt_abl * zztmp1
             u_abl( ji, jj,    2, nt_a ) =      u_abl( ji, jj,    2, nt_a ) + rDt_abl * zztmp2
-			
-            !++ Top Neumann B.C.
-            !z_elem_a( ji,     jpka ) = - 0.5_wp * rDt_abl * ( Avm_abl( ji, jj, jpka )+ Avm_abl( ji+1, jj, jpka ) ) / e3w_abl( jpka ) 
-            !z_elem_c( ji,     jpka ) = 0._wp
-            !z_elem_b( ji,     jpka ) = e3t_abl( jpka ) - z_elem_a( ji,     jpka )                                               
-            !++ Top Dirichlet B.C.
-            z_elem_a( ji,     jpka )       = 0._wp
-            z_elem_c( ji,     jpka )       = 0._wp
-            z_elem_b( ji,     jpka )       = e3t_abl( jpka )
-            u_abl   ( ji, jj, jpka, nt_a ) = e3t_abl( jpka ) * pu_dta(ji,jj,jk)              
-         END DO 
+
+            ! idealized test cases only
+            !IF( ln_topbc_neumann ) THEN
+            !   !++ Top Neumann B.C.
+            !   z_elem_a( ji,     jpka ) = - rDt_abl * Avm_abl( ji, jj, jpka ) / e3w_abl( jpka )
+            !   z_elem_c( ji,     jpka ) = 0._wp
+            !   z_elem_b( ji,     jpka ) = e3t_abl( jpka ) - z_elem_a( ji,     jpka )
+            !   !u_abl   ( ji, jj, jpka, nt_a ) = e3t_abl( jpka ) * u_abl   ( ji, jj, jpka, nt_a )
+            !ELSE
+               !++ Top Dirichlet B.C.
+               z_elem_a( ji,     jpka )       = 0._wp
+               z_elem_c( ji,     jpka )       = 0._wp
+               z_elem_b( ji,     jpka )       = e3t_abl( jpka )
+               u_abl   ( ji, jj, jpka, nt_a ) = e3t_abl( jpka ) * pu_dta(ji,jj,jk)
+            !ENDIF
+
+         END DO
          !!
          !! Matrix inversion
          !! ----------------------------------------------------------
-         DO ji = 2, jpi          
+         !DO ji = 2, jpi
+         DO ji = 1, jpi  !!GS: TBI
             zcff                 =   1._wp / z_elem_b( ji, 2 )
-            zCF   (ji,   2     ) =  - zcff * z_elem_c( ji, 2 ) 
+            zCF   (ji,   2     ) =  - zcff * z_elem_c( ji, 2 )
             u_abl (ji,jj,2,nt_a) =    zcff * u_abl(ji,jj,2,nt_a)
-         END DO             
-
-         DO jk = 3, jpka            
-            DO ji = 2, jpi              
+         END DO
+
+         DO jk = 3, jpka
+            DO ji = 2, jpi
                zcff = 1._wp / ( z_elem_b( ji, jk ) + z_elem_a( ji, jk ) * zCF   (ji, jk-1 ) )
                zCF(ji,jk) = - zcff * z_elem_c( ji, jk )
